unit _Main;

INTERFACE

uses
  Classes, Controls, Dialogs, ExtCtrls, Forms, Graphics, Math, Menus, StdCtrls,
  SysUtils, SpinHex;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    nFile: TMenuItem;
    nFileIn: TMenuItem;
    n1: TMenuItem;
    nDiagramSave: TMenuItem;
    nDiagramLoad: TMenuItem;
    n2: TMenuItem;
    nRestore: TMenuItem;
    nSub: TMenuItem;
    nBefore: TMenuItem;
    nSection: TMenuItem;
    nTrifle: TMenuItem;
    nHexDec: TMenuItem;
    nHint: TMenuItem;
    nAbout: TMenuItem;
    btnPrevious: TButton;
    btnNext: TButton;
    btnCorrupt: TButton;
    EasyHex11: TEasyHex;
    EasyHex12: TEasyHex;
    EasyHexInterval: TEasyHex;
    EasyHex14: TEasyHex;
    SpinHex21: TSpinHex;
    SpinHex22: TSpinHex;
    SpinHex23: TSpinHex;
    SpinHex32: TSpinHex;
    SpinHex31: TSpinHex;
    SpinHex33: TSpinHex;
    SpinHex34: TSpinHex;
    cbInterval: TCheckBox;
    cbRestore: TCheckBox;
    cbAuto: TCheckBox;
    rb22: TRadioButton;
    rb21: TRadioButton;
    rb23: TRadioButton;
    rb33: TRadioButton;
    rb31: TRadioButton;
    rb32: TRadioButton;
    rb34: TRadioButton;
    rb35: TRadioButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    lbReport: TLabel;
    lbChange11: TLabel;
    lbChange12: TLabel;
    lbInterval: TLabel;
    lbChange13: TLabel;
    lb1: TLabel;
    lb2: TLabel;
    lb3: TLabel;
    lb6: TLabel;
    lb5: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel0: TPanel;
    PaintBox2: TPaintBox;
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure btnCorruptClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure EasyHex11KeyPress(Sender: TObject; var Key: Char);
    procedure EasyHex12KeyPress(Sender: TObject; var Key: Char);
    procedure EasyHex14KeyPress(Sender: TObject; var Key: Char);
    procedure EasyHexIntervalChange(Sender: TObject);
    procedure EasyHexIntervalKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure nAboutClick(Sender: TObject);
    procedure nBeforeClick(Sender: TObject);
    procedure nDiagramLoadClick(Sender: TObject);
    procedure nDiagramSaveClick(Sender: TObject);
    procedure nFileInClick(Sender: TObject);
    procedure nHexDecClick(Sender: TObject);
    procedure nHintClick(Sender: TObject);
    procedure nRestoreClick(Sender: TObject);
    procedure nSectionClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2Paint(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
  public
  end;

  function ShowCode(ind, len, nchar: Integer): String;

const
  myColor: array[0..7] of TColor = ($00D8D8D8, $00FF8000, $0000FF00, $000000FF,
                                    $00787878, $00C00000, $0000A000, $00A000C0);

type
  TDiagram = array of record   // 
                      bgn: Integer;  //   
                      cl: Byte;      //    myColor
                      h2: Word;      //     
                      end;

var
  Form1: TForm1;
  arInf: TDiagram;     // ,       bgn =  
  bIsHex: Boolean = true; //  16- 
  arFile: array of Byte;  //  
  strFileName: String;    //  ,  
  indexSelectedRange: Integer;  //     

IMPLEMENTATION

uses _Question, _Section, _Before;

{$R *.dfm}

var F: File;      // 


////////////////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////////////////

//>     ,      
//> ,   . ..     
//>  .
function CanBeRestored: Boolean;
var ar: array of byte;
    i: integer;
begin
  {$I-}
  Reset(F,1);
  {$I+}
  if IOResult<>0
    then begin
         result := true;
         EXIT;
         end;

  i:=FileSize(F);
  If i<>Length(arFile)
    then begin
         result := true;
         CloseFile(F);
         EXIT;
         end;

  SetLength(ar,i);
  BlockRead(F,ar[0],i);
  CloseFile(F);
  For i:=0 to pred(i) do
     If ar[i]<>arFile[i]
       then begin
            result := true;
            EXIT;
            end;

  result := false;
end;


//>   ,   ٨
//>     
function DefinitionRangeNumber1(y: integer): integer;
begin
  IF y<=41 THEN result:=0
  ELSE
  IF y>=34*Length(arInf)-60 THEN result:=Length(arInf)-2
  ELSE result := (y-8) div 34;
end;
function DefinitionRangeNumber2(y: integer): integer;
var
  i: integer;
begin
  For i:=Length(arInf)-2 downto 1 do
     if y>=arInf[i].h2
       then begin
            result:=i;
            EXIT;
            end;
  result:=0;
end;


//>        
procedure DrawNumber1(x,y,number: integer);
begin
  if bIsHex
    then Form1.PaintBox1.Canvas.TextOut(x,y,IntToHex(number,1))
    else Form1.PaintBox1.Canvas.TextOut(x,y,IntToStr(number))
end;
procedure DrawNumber2(x,y,number: integer);
begin
  if bIsHex
    then Form1.PaintBox2.Canvas.TextOut(x,y,IntToHex(number,1))
    else Form1.PaintBox2.Canvas.TextOut(x,y,IntToStr(number))
end;


//>     
procedure RefreshAllDiagrams;
begin
  With Form1 do
      begin
      PaintBox1.Canvas.FillRect(Rect(0,0,PaintBox1.Width,PaintBox1.Height));
      PaintBox1Paint(nil);
      PaintBox2.Canvas.FillRect(Rect(0,0,PaintBox2.Width,PaintBox2.Height));
      PaintBox2Paint(nil);
      end
end;


//>   .
procedure RestoreFile;
begin
  Rewrite(F,1);
  BlockWrite(F,arFile[0],Length(arFile));
  CloseFile(F);
  Form1.lbReport.Caption := Concat(' '#13'''',ExtractFileName(strFileName),''''#13' ');
end;


//>     ,  
//>      
procedure RollToSelectedRange;
begin
  With Form1.ScrollBar1 do
      If Visible
        then
            if Position>34*indexSelectedRange
              then
                  Position:=34*indexSelectedRange
              else
                  if Position+LargeChange<34*indexSelectedRange+50
                    then Position:=34*indexSelectedRange+50-LargeChange;
end;


//>           
//> ind -    
//> len -     '|'
//> nchar -  ,        '|'(  36)
function ShowCode(ind, len, nchar: Integer): String;
var str1, str2: String[113];       //  (  )
    arTemp: array [0..37] of byte; //      
    j,k: Integer;
begin
  nchar := min(nchar,Length(arFile)-ind);
  Reset(F,1);

  If ind>1
    then begin
         Seek(F,ind-2);
         BlockRead(F,arTemp[0],nchar+2);
         str1 := IntToHex(arFile[ind-2],2)+' '+IntToHex(arFile[ind-1],2);
         str2 := IntToHex(arTemp[0],2)+' '+IntToHex(arTemp[1],2);
         end
    else     //     ,       
         if ind=1
           then begin
                BlockRead(F,arTemp[1],nchar+1);
                str1 := '   '+IntToHex(arFile[0],2);
                str2 := '   '+IntToHex(arTemp[1],2);
                end
           else begin
                BlockRead(F,arTemp[2],nchar);
                str1 := '     ';
                str2 := '     ';
                end;
  CloseFile(F);

  k := 2;        //   '|'
  For j:=ind to pred(ind+nchar)
     do begin
        str1 := Concat(str1, ' ', IntToHex(arFile[j],2));
        str2 := Concat(str2, ' ', IntToHex(arTemp[k],2));
        inc(k);
        end;

  str1[6] := '|';
  str2[6] := '|';
  If len<nchar
    then begin
         str1[6+len*3] := '|';
         str2[6+len*3] := '|';
         end;

  result := Concat(str1, #13#10, str2);
end;


//>      
procedure TotalRecalculation;
Var r: Real;
    i: Integer;
begin
  If arInf=nil then EXIT;

  WITH Form1 DO
      BEGIN                    //     
      r:=arInf[High(arInf)].bgn/(((Panel2.Height-14)div 20 )*20-1);  //   1    
      arInf[0].h2:=9;          //      
      For i:=1 to High(arInf) do
         begin
         arInf[i].h2:=Round(arInf[i].bgn/r) + 9;
         if arInf[i].h2<=arInf[pred(i)].h2         //       (   )
           then arInf[pred(i)].h2:=pred(arInf[pred(i)].h2)
         end;

      PaintBox1.Height:=34*i-18;       //   PaintBox1,      

      If PaintBox1.Height<=Panel1.ClientHeight   //  
        then begin
             ScrollBar1.Position:=0;
             ScrollBar1.Visible:=false;
             end
        else begin
             ScrollBar1.PageSize:=1;  //          
             ScrollBar1.Max:=pred(PaintBox1.Height);
             ScrollBar1.LargeChange:=Panel1.ClientHeight;
             ScrollBar1.PageSize:=ScrollBar1.LargeChange;
             ScrollBar1.Visible:=true;
             end;

      ScrollBar1Change(nil);   // ,            
      END;

  RefreshAllDiagrams;
end;





////////////////////////////////////////////////////////////////////////////////////////////
//                             
////////////////////////////////////////////////////////////////////////////////////////////

//>     " "
procedure TForm1.btnCorruptClick(Sender: TObject);
var byteMin, byteMax: Byte; //    
    iBegin, iEnd: Integer;  //    
    i,j,k,m: Integer;
    bt, bt2, bt3: Byte;
    ar: array of Byte;
    hi: integer;            //   ar
    str: string;
begin
  iBegin := EasyHex11.Value;
  iEnd := EasyHex12.Value;
  If iBegin>iEnd
    then begin
         MessageDlg('    . , .',
                    mtWarning, [mbOK], 0);
         EXIT;
         end;

  IF rb21.Checked THEN begin
                       byteMin := SpinHex21.Value;
                       byteMax := SpinHex22.Value;
                       if byteMin>byteMax
                         then begin
                              MessageDlg('     . , .',
                                         mtWarning, [mbOK], 0);
                              EXIT;
                              end;
                       end
  ELSE
  IF rb22.Checked THEN begin
                       byteMin := 0;
                       byteMax := 255;
                       end
  ELSE  //if rb23.Checked
                       begin
                       byteMin := SpinHex23.Value;
                       byteMax := byteMin;
                       end;

  If (byteMin=byteMax) and (rb31.Checked or rb32.Checked)
    then begin
         MessageDlg(' ,       /  ,        .     .',
                    mtWarning, [mbOK], 0);
         EXIT;
         end;

{}hi := iEnd-iBegin;
{}SetLength(ar,Succ(hi));
{}Move(arFile[iBegin],ar[0],Length(ar));
{}IF cbInterval.Checked
{}  THEN BEGIN
{}       i := 0;
{}       j := EasyHexInterval.Value;
{}       IF rb31.Checked THEN begin
{}                            k := SpinHex31.Value;
{}                            While i<=hi do
{}                                 begin
{}                                 if (byteMin<=ar[i]) and (ar[i]<byteMax)
{}                                   then begin
{}                                        m := k+ar[i];
{}                                        if m<=byteMax
{}                                          then ar[i]:=m
{}                                          else ar[i]:=byteMax
{}                                        end;
{}                                 Inc(i,j);
{}                                 end;
{}                            end
{}       ELSE
{}       IF rb32.Checked THEN begin
{}                            k := SpinHex31.Value;
{}                            While i<=hi do
{}                                 begin
{}                                 if (byteMin<ar[i]) and (ar[i]<=byteMax)
{}                                   then begin
{}                                        m := ar[i]-k;
{}                                        if m>=byteMin
{}                                          then ar[i]:=m
{}                                          else ar[i]:=byteMin
{}                                        end;
{}                                 Inc(i,j);
{}                                 end;
{}                            end
{}       ELSE
{}       IF rb33.Checked THEN begin
{}                            bt := SpinHex32.Value;
{}                            While i<=hi do
{}                                 begin
{}                                 if (byteMin<=ar[i]) and (ar[i]<=byteMax)
{}                                   then ar[i]:=bt;
{}                                 Inc(i,j);
{}                                 end;
{}                            end
{}       ELSE
{}       IF rb34.Checked THEN begin
{}                            MessageDlg('     ''    xx- '',     .',
{}                                       mtWarning, [mbOK], 0);
{}                            EXIT;
{}                            end
{}       ELSE  //if rb35.Checked
{}                            While i<=hi do
{}                                 begin
{}                                 if (byteMin<=ar[i]) and (ar[i]<=byteMax)
{}                                   then ar[i]:=Random(256);
{}                                 Inc(i,j);
{}                                 end;
{}       END
    ELSE
{}       IF rb31.Checked THEN begin
{}                            k := SpinHex31.Value;
{}                            For i:=0 to hi do
{}                               if (byteMin<=ar[i]) and (ar[i]<byteMax)
{}                                 then begin
{}                                      m := k+ar[i];
{}                                      if m<=byteMax
{}                                        then ar[i]:=m
{}                                        else ar[i]:=byteMax;
{}                                      end
{}                            end
{}       ELSE
{}       IF rb32.Checked THEN begin
{}                            k := SpinHex31.Value;
{}                            For i:=0 to hi do
{}                               if (byteMin<ar[i]) and (ar[i]<=byteMax)
{}                                 then begin
{}                                      m := ar[i]-k;
{}                                      if m>=byteMin
{}                                        then ar[i]:=m
{}                                        else ar[i]:=byteMin;
{}                                      end
{}                            end
{}       ELSE
{}       IF rb33.Checked THEN begin
{}                            bt := SpinHex32.Value;
{}                            For i:=0 to hi do
{}                               if (byteMin<=ar[i]) and (ar[i]<=byteMax)
{}                                 then ar[i]:=bt
{}                            end
{}       ELSE
{}       IF rb34.Checked THEN begin
{}                            if (byteMin<>0) or (byteMax<>255)
{}                              then begin
{}                                   MessageDlg('   ,        (..  $0  $FF)',
{}                                              mtWarning, [mbOK], 0);
{}                                   EXIT;
{}                                   end;
{}                            bt2 := SpinHex33.Value;
{}                            bt3 := SpinHex34.Value;
{}                            if bt2<=bt3
{}                              then begin     // 
{}                                   bt := bt3;
{}                                   for i:=0 to hi do
{}                                      if bt<bt3
{}                                        then begin
{}                                             Inc(bt);
{}                                             ar[i]:=bt;
{}                                             end
{}                                        else begin
{}                                             bt:=bt2;
{}                                             ar[i]:=bt;
{}                                             end;
{}                                   end
{}                              else begin     // 
{}                                   bt := bt3;
{}                                   for i:=0 to hi do
{}                                      if bt>bt3
{}                                        then begin
{}                                             Dec(bt);
{}                                             ar[i]:=bt;
{}                                             end
{}                                        else begin
{}                                             bt:=bt2;
{}                                             ar[i]:=bt;
{}                                             end;
{}                                   end;
{}                            end
{}       ELSE   //if rb35.Checked
{}                            for i:=0 to hi do
{}                               if (byteMin<=ar[i]) and (ar[i]<=byteMax)
{}                                 then ar[i]:=Random(256);
{}RESET(F,1);
{}SEEK(F,iBegin);
{}BlockWrite(F,ar[0],Succ(hi));
{}CLOSEFILE(F);

  ar := nil;
  Form2.Memo2.Text := ShowCode(iBegin, Length(ar),24);
  If rb31.Checked or rb32.Checked
    then Form2.lb4.Caption := Format('(  ,    /          .    $%2.2x  $%2.2x.)',
                                     [byteMin,byteMax])
    else Form2.lb4.Caption := '';
  Form2.ShowModal;
  TotalRecalculation;
  RollToSelectedRange;

  If cbRestore.Checked
    then begin               // 
         Reset(F,1);
         Seek(F,iBegin);
         BlockWrite(F,arFile[iBegin],Succ(hi));
         CloseFile(F);
         end;
  Memo1.Text := ShowCode(arInf[indexSelectedRange].bgn,arInf[succ(indexSelectedRange)].bgn-arInf[indexSelectedRange].bgn,12);

  str := ' ';  //    
  If bIsHex
    then str := Concat(str,#13'c ',IntToHex(iBegin,1),' h    ',IntToHex(iEnd,1),' h')
    else str := Concat(str,#13'c ',IntToStr(iBegin),' d    ',IntToStr(iEnd),' d');
  If cbInterval.Checked
    then begin
         j:=EasyHexInterval.Value;
         str := Concat(str,#13'  ',IntToStr(j));
         if (9<=j) and (j<=21)
           then str:=str+'- '
           else
               case j mod 10 of
                   2,6,7,8: str:=str+'- ';
                   3: str:=str+'- ';
                   else str:=str+'- ';  //1,4,5,9
                   end;
         end
    else
         str := str+#13' ';
  If cbRestore.Checked
    then str := str+#13'( )'
    else str := str+#13'(  )';
  lbReport.Caption := str;

  If cbAuto.Checked
    then begin
         btnNextClick(nil);
         btnCorrupt.SetFocus;
         end
    else EasyHex11.SetFocus;
end;


//>   
procedure TForm1.btnNextClick(Sender: TObject);
begin
  EasyHex11.Value := Succ(EasyHex12.Value);
  EasyHex12.Value := EasyHex12.Value + EasyHex14.Value;
end;


//>   
procedure TForm1.btnPreviousClick(Sender: TObject);
begin
  EasyHex12.Value := Pred(EasyHex11.Value);
  EasyHex11.Value := EasyHex11.Value - EasyHex14.Value;
end;


//>   ,    
procedure TForm1.EasyHex11KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnCorruptClick(nil);
end;
procedure TForm1.EasyHex12KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnCorruptClick(nil);
end;
procedure TForm1.EasyHex14KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnCorruptClick(nil);
end;
procedure TForm1.EasyHexIntervalChange(Sender: TObject);
begin
  If (EasyHexInterval.Value mod 10 = 3) and (EasyHexInterval.Value<>13)
    then lbInterval.Caption:='- '
    else lbInterval.Caption:='- ';
end;
procedure TForm1.EasyHexIntervalKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnCorruptClick(nil);
end;


//>         
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  If arFile=nil then EXIT;
  If CanBeRestored
    then
        Case MessageDlg('       . ,      ?',
             mtConfirmation, mbYesNoCancel, 0) of
             mrYes: RestoreFile;
             mrNo: ;
             else CanClose := false;
             end
end;


//>          
//>   WINDOWS
procedure TForm1.FormCreate(Sender: TObject);
var d: Integer;
begin
  d := ClientOrigin.X-Left;
  Constraints.MaxWidth := 646+d*2;
  Constraints.MinWidth := Constraints.MaxWidth;
  Constraints.MinHeight := 625+ClientOrigin.Y-Top+d;

  Panel1.Height := ClientHeight-5;  //      Windows   
  Panel2.Height := ClientHeight-5;
  Canvas.Pen.Color := clGray;    //   

  Application.ShowHint := false;
  Application.HintHidePause := 60000;
end;


//>        
procedure TForm1.FormPaint(Sender: TObject);
var x,y: Integer;
begin
  x := Memo1.Left+41;
  y := Memo1.Top+29;
  With Canvas do
      begin
      MoveTo(x,y);
      LineTo(x,y+4);
      MoveTo(x+84,y);
      LineTo(x+84,y+4);
      MoveTo(x+168,y);
      LineTo(x+168,y+4);
      end;
end;


//>      
procedure TForm1.FormResize(Sender: TObject);
begin
  TotalRecalculation;
end;


//>     
procedure TForm1.nAboutClick(Sender: TObject);
var str: String;
begin
  str := ':'#9#9''#13+
         ':'#9#9#9'1.0'#13+
         ' :'#9' 2009'#13+
         ':'#9#9#9'BlueHairLady'#13+
         'E-mail:'#9#9#9'bhlady@mail.ru'#13+
         'WWW-'#13':'#9#9'http://bhlady.narod.ru/programs/romcor.htm';
  MessageDlg(str, mtInformation, [mbOK], 0)
end;


//>        
procedure TForm1.nBeforeClick(Sender: TObject);
begin
  If Length(arFile)<16
    then begin
         MessageDlg('           16 .        16  .',
                    mtInformation, [mbOK], 0);
         EXIT;
         end;
  Form3.ShowModal;

  TotalRecalculation;
  Memo1.Text := ShowCode(arInf[indexSelectedRange].bgn,arInf[succ(indexSelectedRange)].bgn-arInf[indexSelectedRange].bgn,12);
  RollToSelectedRange;
end;


//>     "  "
procedure TForm1.nDiagramLoadClick(Sender: TObject);
var TF: TextFile;
    ar: TDiagram;
    i: Integer;
begin
  OpenDialog1.Title := '   ';
  OpenDialog1.Filter := ' |*.*|  (*.txt)|*.txt';
  OpenDialog1.FilterIndex := 2;

  If not OpenDialog1.Execute then EXIT;

  AssignFile(TF,OpenDialog1.FileName);
  {$I-}
  Reset(TF);
  If IOResult<>0
    then begin
         MessageDlg('    .  .',
                    mtError, [mbOK], 0);
         EXIT;
         end;
  Readln(TF);
  Readln(TF);
  i := 0;
  While not EOF(TF) do
       begin
       SetLength(ar,succ(i));
       ReadLn(TF,ar[i].bgn,ar[i].cl);
       inc(i);
       end;
  {$I+}

  If (IOResult<>0) or (i<2)
    then begin
         MessageDlg('    .  .',
                    mtError, [mbOK], 0);
         CloseFile(TF);
         EXIT;
         end;
  CloseFile(TF);

  If arFile=nil            //     
    then begin
         arInf:=ar;
         TotalRecalculation;
         Memo1.Text := '   ,'#13#10'   ';
         EXIT;
         end;

  If ar[High(ar)].bgn<>Length(arFile)
    then begin
         MessageDlg('      ,     .  .',
                    mtWarning, [mbOK], 0);
         EXIT;
         end;

  arInf:=ar;
  indexSelectedRange := 0;
  TotalRecalculation;
  Memo1.Text := ShowCode(0,arInf[1].bgn-arInf[0].bgn,12);
end;


//>     "  "
procedure TForm1.nDiagramSaveClick(Sender: TObject);
var TF: TextFile;
    i: Integer;
begin
  If not SaveDialog1.Execute then EXIT;

  AssignFile(TF,SaveDialog1.FileName);
  ReWrite(TF);
  WriteLn(TF,'     '''+ExtractFileName(strFileName)+'''.');
  WriteLn(TF,'   '+DateToStr(now)+'   v1.0.');

  For i:=0 to High(arInf) do
     Writeln(TF,arInf[i].bgn,#9,arInf[i].cl);

  CloseFile(TF);

  MessageDlg(',    ,   .',
              mtInformation, [mbOK], 0);
end;


//>     "   "
procedure TForm1.nFileInClick(Sender: TObject);
var i: Integer;
begin
  IF Length(arFile)<>0   //    - 
    THEN
        If CanBeRestored
          then
              case MessageDlg('      .   ,        ?',
                   mtConfirmation, mbYesNoCancel, 0) of
                  mrYes: RestoreFile;
                  mrNo: ;
                  else EXIT;
                  end;
//----------------------------------
  OpenDialog1.Title := '   ';
  OpenDialog1.Filter := ' |*.*|NES (*.nes)|*.nes|GameBoy (*.gb, *.gbc)|*.gb; *.gbc|SNES (*.smc, *.fig)|*.smc; *.fig|Sega Genesis (*.smd, *.bin)|*.smd; *.bin|GBA (*.gba)|*.gba';
  OpenDialog1.FilterIndex := 1;
  if strFileName<>'' then OpenDialog1.FileName := strFileName;
  If not OpenDialog1.Execute then EXIT;
//----------------------------------
  strFileName := OpenDialog1.FileName;
  AssignFile(F,strFileName);
  {$I-}                                     //   
  Reset(F,1);
  {$I+}
  if IOResult<>0
    then begin
         MessageDlg('.     '#13''''+strFileName+''''#13' .',
                    mtError, [mbOK], 0);
         EXIT;
         end;

  i:=FileSize(F);
  if i=0 then begin
              MessageDlg(' .    .',
                         mtInformation, [mbOK], 0);
              CloseFile(F);
              EXIT;
              end;
  EasyHex14.ValueMax := pred(i);
  if arFile=nil       //  ,          
    then EasyHex14.Value := 4096;
  SetLength(arFile,i);
  BlockRead(F,arFile[0],i);
  CloseFile(F);                      // ,   

  Caption := '   -   [ . . \ '+ExtractFileName(strFileName)+' ]';
  SetLength(arInf,2);                //  
  arInf[0].bgn := 0;
  arInf[0].cl := 0;
  arInf[1].bgn := i;
  arInf[1].cl := 77;          //      (1)
  indexSelectedRange := 0;
  TotalRecalculation;
  Memo1.Text := ShowCode(0,12,12);

  EasyHex11.ValueMax := pred(i);     //  
  EasyHex11.Value := 0;              //  
  EasyHex12.ValueMax := pred(i);
  EasyHex12.Value := EasyHex14.Value;
  btnPrevious.Enabled := true;
  btnNext.Enabled := true;
  btnCorrupt.Enabled := true;
  nDiagramSave.Enabled := true;
  nRestore.Enabled := true;
  nBefore.Enabled := true;
  nSection.Enabled := true;

  Form2.lbFile.Caption := strFileName;
end;


//>   10-  16-   
procedure TForm1.nHexDecClick(Sender: TObject);
begin
  If bIsHex
    then begin
         bIsHex := false;
         EasyHex11.IsSystemHex := false;
         EasyHex12.IsSystemHex := false;
         EasyHex14.IsSystemHex := false;
         lbChange11.Caption := 'd   ';
         lbChange12.Caption := 'd';
         lbChange13.Caption := 'd  ';
         NHexDec.Caption := '   16-  ';
         end
    else begin
         bIsHex := true;
         EasyHex11.IsSystemHex := true;
         EasyHex12.IsSystemHex := true;
         EasyHex14.IsSystemHex := true;
         lbChange11.Caption := 'h   ';
         lbChange12.Caption := 'h';
         lbChange13.Caption := 'h  ';
         NHexDec.Caption := '   10-  ';
         end;
  RefreshAllDiagrams;
end;


//>     
procedure TForm1.nHintClick(Sender: TObject);
begin
  If Application.ShowHint
    then nHint.Caption:='  '
    else nHint.Caption:='  ';
  Application.ShowHint := not(Application.ShowHint);
end;


//>     "    "
procedure TForm1.nRestoreClick(Sender: TObject);
begin
  If CanBeRestored
    then RestoreFile
    else MessageDlg('  ,     .    .',
                    mtInformation, [mbOK], 0);
end;


//>   ר    ˨ 
procedure TForm1.nSectionClick(Sender: TObject);
begin
  Form4.ShowModal;
end;


//>     
procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: Integer;
begin
  If arInf=nil then EXIT;

  i := DefinitionRangeNumber1(y);
  If i=indexSelectedRange
    then begin
         EasyHex11.Value := arInf[i].bgn;
         EasyHex12.Value := pred(arInf[succ(i)].bgn);
         end
    else begin
         indexSelectedRange := i;
         RefreshAllDiagrams;     //      
         if arFile<>nil
           then Memo1.Text := ShowCode(arInf[i].bgn,arInf[succ(i)].bgn-arInf[i].bgn,12);
         end;
end;


//>   
procedure TForm1.PaintBox1Paint(Sender: TObject);
const LEFTSPACE = 31;
var i,h: Integer;
begin
  If arInf=nil then EXIT;
  h := 8;

  With PaintBox1.Canvas do
      begin
      For i:=0 to Length(arInf)-2 do   //  (   arInf  ,   )
         begin
         Brush.Color := myColor[arInf[i].cl];         // 
         Rectangle(LEFTSPACE,h,LEFTSPACE+35,h+35);
         Brush.Color := clWhite;

         Font.Color := clMaroon;          //  
         Font.Name := 'Estrangelo Edessa';
         TextOut(LEFTSPACE-3-Length(IntToStr(succ(i)))*6,h+12,IntToStr(succ(i)));

         Font.Color := myColor[arInf[i].cl];     // 
         Font.Name := 'Courier';
         DrawNumber1(LEFTSPACE+54,h+11,arInf[succ(i)].bgn-arInf[i].bgn);

         Font.Color := clBlack;                        // 
         DrawNumber1(LEFTSPACE+38,h-1,arInf[i].bgn);   //   
         DrawNumber1(LEFTSPACE+38,h+22,pred(arInf[succ(i)].bgn));

         Inc(h,34);
         end;

      Pen.Color := $00CF0000;            //  
      Pen.Width := 5;
      MoveTo(7,8+34*indexSelectedRange);
      LineTo(7,42+34*indexSelectedRange);
      Pen.Color := clBlack;
      Pen.Width := 1;
      end;
end;


//>     
procedure TForm1.PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: Integer;
begin
  If arInf=nil then EXIT;

  i := DefinitionRangeNumber2(y);
  If i=indexSelectedRange
    then begin
         EasyHex11.Value := arInf[i].bgn;
         EasyHex12.Value := pred(arInf[succ(i)].bgn);
         end
    else begin
         indexSelectedRange := i;
         RefreshAllDiagrams;
         if arFile<>nil
           then Memo1.Text := ShowCode(arInf[i].bgn,arInf[succ(i)].bgn-arInf[i].bgn,12);
         end;
  RollToSelectedRange;
end;


//>   
procedure TForm1.PaintBox2Paint(Sender: TObject);
const LEFTSPACE = 31;
var i,j,h: Integer;
begin
  With PaintBox2.Canvas do
      begin
      Font.Color:=$00CF0000;       //      
      If bIsHex
        then TextOut(Panel2.Width-28,1,'HEX')
        else TextOut(Panel2.Width-28,1,'DEC');

      If arInf=nil then EXIT;

      h:=((Panel2.Height-14)div 20)*20;  //  
      //Rectangle(LEFTSPACE,8,LEFTSPACE+35,9+h);    //- ,          ,   

      For i:=0 to Length(arInf)-2 do   // 
         begin
         Brush.Color := myColor[arInf[i].cl];
         FillRect(Rect(LEFTSPACE+1,arInf[i].h2,LEFTSPACE+34,arInf[succ(i)].h2));
         Brush.Color:=clWhite;
         Font.Color:=clMaroon;
         Font.Name:='Estrangelo Edessa';
         TextOut(LEFTSPACE-3-Length(IntToStr(succ(i)))*6,(arInf[succ(i)].h2+arInf[i].h2) shr 1 -5,IntToStr(succ(i)));  // 
         Font.Color:=clBlack;
         Font.Name:='Courier';
         DrawNumber2(LEFTSPACE+38,arInf[succ(i)].h2-12,pred(arInf[succ(i)].bgn)); // 
         DrawNumber2(LEFTSPACE+38,arInf[i].h2-1,arInf[i].bgn);                    //   
         end;

      MoveTo(LEFTSPACE,8);LineTo(LEFTSPACE,h+8);LineTo(LEFTSPACE+34,h+8);LineTo(LEFTSPACE+34,8);LineTo(LEFTSPACE,8);
      h:=h div 20;            // 
      j:=8;
      For i:=1 to 10 do
         begin
         inc(j,h);
         MoveTo(LEFTSPACE+32,j);
         LineTo(LEFTSPACE+34,j);
         inc(j,h);
         MoveTo(LEFTSPACE+27,j);
         LineTo(LEFTSPACE+34,j);
         end;
      MoveTo(LEFTSPACE+18,8+h*10);
      LineTo(LEFTSPACE+27,8+h*10);

      Pen.Color := $00CF0000;           //  
      Pen.Width := 5;
      MoveTo(7,arInf[indexSelectedRange].h2);
      LineTo(7,arInf[succ(indexSelectedRange)].h2);
      Pen.Color:=clBlack;
      Pen.Width:=1;
      end;
end;


//>        PAINTBOX,
//>     
procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  With ScrollBar1 do
      begin
      if Position>succ(Max-PageSize)
        then Position:=succ(Max-PageSize);
      PaintBox1.Top:=-Position;
      end;
end;

end.

